<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on November 13, 2008 at 2:05:40 pm</time-stamp>
<!-- Package Changes for PV-DM-Support(Green.23,spair)* -->


<methods>
<class-id>PROVISO.PvDomainObject</class-id> <category>persistence</category>

<body package="PV-DM-Support" selector="proxifyIn:">proxifyIn: aPvModel 
	"Turn the receiver into a proxy (if possible)."
	
	| myPosition repos |
	repos := aPvModel repository.
	repos ifNil: [^self].
	repos critical: 
		[myPosition := self journalPosition.
		(self id isNil or: [myPosition isNil]) 
			ifTrue: 
				["The receiver cannot be proxified because it doesn't have enough information to retrieve the domain object from the repository.  Just answer the receiver."^self].
		self become: 
			(self 
				asProxyIn: aPvModel
				position: myPosition)]</body>
</methods>

<methods>
<class-id>PROVISO.PvDomainProxy</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="dereference">dereference
	"Turn the receiver into the real domain object...ensure that we don't screw up caches by taking a shallow copy of the object retrieved from the repository."
	
	| rep newMe jp myPvModel |
	myPvModel := self pvModel.
	(rep := myPvModel repository) ifNil: [^nil error: 'missing repository binding'].
	rep critical: 
		[jp := self journalPosition.
		newMe := (rep atJournalPosition: jp) shallowCopy.
		newMe journalPosition: jp].
	newMe flags: self flags.
	newMe element: self element.
	self become: newMe.
	"The following call will initialize any reified relationships."
	newMe postInsertUpdateIn: myPvModel</body>
</methods>


</st-source>
